# DO NOT EDIT! This file was auto-generated by crates/re_types_builder/src/codegen/python.rs
# Based on "crates/re_types/definitions/rerun/blueprint/components/row_shares.fbs".

# You can extend this class by creating a "RowSharesExt" class in "row_shares_ext.py".

from __future__ import annotations

from typing import Any, Sequence, Union

import numpy as np
import numpy.typing as npt
import pyarrow as pa
from attrs import define, field

from ..._baseclasses import BaseBatch, BaseExtensionType, ComponentBatchMixin
from ..._converters import (
    to_np_float32,
)

__all__ = ["RowShares", "RowSharesArrayLike", "RowSharesBatch", "RowSharesLike", "RowSharesType"]


@define(init=False)
class RowShares:
    """**Component**: The layout shares of each row in the container."""

    def __init__(self: Any, shares: RowSharesLike):
        """
        Create a new instance of the RowShares component.

        Parameters
        ----------
        shares:
            The layout shares of each row in the container.
        """

        # You can define your own __init__ function as a member of RowSharesExt in row_shares_ext.py
        self.__attrs_init__(shares=shares)

    shares: npt.NDArray[np.float32] = field(converter=to_np_float32)
    # The layout shares of each row in the container.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    def __array__(self, dtype: npt.DTypeLike = None) -> npt.NDArray[Any]:
        # You can define your own __array__ function as a member of RowSharesExt in row_shares_ext.py
        return np.asarray(self.shares, dtype=dtype)


RowSharesLike = RowShares
RowSharesArrayLike = Union[
    RowShares,
    Sequence[RowSharesLike],
]


class RowSharesType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.components.RowShares"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(
            self, pa.list_(pa.field("item", pa.float32(), nullable=False, metadata={})), self._TYPE_NAME
        )


class RowSharesBatch(BaseBatch[RowSharesArrayLike], ComponentBatchMixin):
    _ARROW_TYPE = RowSharesType()

    @staticmethod
    def _native_to_pa_array(data: RowSharesArrayLike, data_type: pa.DataType) -> pa.Array:
        raise NotImplementedError  # You need to implement native_to_pa_array_override in row_shares_ext.py
